import java.io.IOException;
import java.io.InputStream;
import java.io.StreamTokenizer;
import java.net.URL;

class CellUpdater extends Thread {
   Cell target;
   InputStream dataStream;
   StreamTokenizer tokenStream;

   public CellUpdater(Cell c) {
      super("cell updater");
      this.target = c;
   }

   public void run() {
      try {
         this.dataStream = (new URL(this.target.app.getDocumentBase(), this.target.getValueString())).openStream();
         this.tokenStream = new StreamTokenizer(this.dataStream);
         this.tokenStream.eolIsSignificant(false);

         while(true) {
            switch (this.tokenStream.nextToken()) {
               case -2:
                  this.target.setTransientValue((float)this.tokenStream.nval);
                  if (!this.target.app.isStopped && !this.target.paused) {
                     this.target.app.repaint();
                  }
               default:
                  try {
                     Thread.sleep(2000L);
                     break;
                  } catch (InterruptedException var1) {
                     return;
                  }
               case -1:
                  this.dataStream.close();
                  return;
            }
         }
      } catch (IOException var2) {
      }
   }
}
